"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
var append_event_exports = {};
__export(append_event_exports, {
  appendEvent: () => appendEvent,
  appendEvents: () => appendEvents,
  writeEvents: () => writeEvents
});
module.exports = __toCommonJS(append_event_exports);
var import_promises = __toESM(require("fs/promises"));
var import_path = __toESM(require("path"));
var import_header = require("./header");
const log = require("@home-gallery/logger")("events.append");
const stringifyNdJson = (value) => JSON.stringify(value) + "\n";
const writeEvents = (eventsFilename, events) => __async(void 0, null, function* () {
  const t0 = Date.now();
  const exists = yield import_promises.default.access(eventsFilename).then(() => true).catch(() => false);
  if (!exists) {
    yield import_promises.default.mkdir(import_path.default.dirname(eventsFilename.toString()), { recursive: true });
  }
  const data = stringifyNdJson((0, import_header.createHeader)()) + events.map(stringifyNdJson).join("");
  yield import_promises.default.writeFile(eventsFilename, data);
  log.debug(t0, `Wrote ${events.length} events to ${eventsFilename}`);
});
const appendEvents = (eventsFilename, events) => __async(void 0, null, function* () {
  const t0 = Date.now();
  const stat = yield import_promises.default.stat(eventsFilename).catch((err) => err.code == "ENOENT" ? false : Promise.reject(err));
  if (!stat || (stat == null ? void 0 : stat.size) === 0) {
    log.debug(`Events file ${eventsFilename} is missing or empty. Write new file`);
    return writeEvents(eventsFilename, events);
  }
  yield import_promises.default.appendFile(eventsFilename, events.map(stringifyNdJson).join(""));
  log.debug(t0, `Append ${events.length} events to ${eventsFilename}`);
});
const appendEvent = (eventsFilename, event) => appendEvents(eventsFilename, [event]);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  appendEvent,
  appendEvents,
  writeEvents
});
//# sourceMappingURL=append-event.js.map
