"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
var merge_events_exports = {};
__export(merge_events_exports, {
  mergeEvents: () => mergeEvents
});
module.exports = __toCommonJS(merge_events_exports);
var import_promises = __toESM(require("fs/promises"));
var import_read_events = require("./read-events");
var import_append_event = require("./append-event");
const log = require("@home-gallery/logger")("events.merge");
const byDate = (a, b) => {
  if (a.date && b.date) {
    return a.date < b.date ? -1 : 1;
  } else if (a.date) {
    return 1;
  } else {
    return -1;
  }
};
const mergeEvents = (eventsFilename, events) => __async(void 0, null, function* () {
  if (!(events == null ? void 0 : events.length)) {
    log.debug(`Given events are empty. Skip merge`);
    return;
  }
  const exists = yield import_promises.default.access(eventsFilename).then(() => true).catch(() => false);
  if (!exists) {
    log.debug(`Event file ${eventsFilename} does not exists, create new event file`);
    yield (0, import_append_event.writeEvents)(eventsFilename, events);
    return events;
  }
  const fileEvents = yield (0, import_read_events.readEvents)(eventsFilename);
  const ids = fileEvents.data.reduce((result, event) => {
    result[event.id] = event;
    return result;
  }, {});
  const uniqNewEvents = events.filter((event) => !ids[event.id]);
  if (!uniqNewEvents.length) {
    log.info(`No new events found. Skip merge`);
    return uniqNewEvents;
  }
  const merged = fileEvents.data.concat(uniqNewEvents).sort(byDate);
  yield (0, import_append_event.writeEvents)(eventsFilename, merged);
  return uniqNewEvents.sort(byDate);
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  mergeEvents
});
//# sourceMappingURL=merge-events.js.map
