"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.which = void 0;
const node_fs_1 = require("node:fs");
const promises_1 = require("node:fs/promises");
const node_path_1 = require("node:path");
const node_process_1 = require("node:process");
const String_1 = require("./String");
async function which(binary) {
    for (const dir of (0, String_1.toS)(node_process_1.env.PATH).split(node_path_1.delimiter)) {
        const fullPath = (0, node_path_1.join)(dir, binary);
        try {
            await (0, promises_1.access)(fullPath, node_fs_1.constants.R_OK | node_fs_1.constants.X_OK);
            return fullPath;
        }
        catch {
            //
        }
    }
    return;
}
exports.which = which;
//# sourceMappingURL=Which.js.map